<?php

    // konfigurace 
    // doplnte hodnoty ziskane pri registraci aplikace
    
    $auth_config['url'] = 'https://auth.fs.cvut.cz/';
    $auth_config['app'] = '<JMENO-APLIKACE>';    
    $auth_config['key'] = '<PRIDELENY-KLIC>';    
    
    /* seznam funkci
     
     auth_login_url() .. vrati prihlasovaci URL
     auth_logout_url() .. vrati odhlasovaci URL
     auth_parse_url_response() .. vyhodnoti prichazejici url (GET) a vrati informace o uzivateli
     auth_check_token($token) .. overi $token a vrati atributy uzivatele
    
    */
    
    // funkce, dale neni treba a nemelo by se nic menit    
    // ---------------------------------------------------------------------------------------------------------------------------------------------

    function auth_login_url() {	
        global $auth_config;
        return $auth_config['url'].'app/'.$auth_config['app'].'/login';    
    }

    function auth_logout_url() {	
        global $auth_config;
        return $auth_config['url'].'app/'.$auth_config['app'].'/logout';    
    }

    
    function auth_parse_url_response() {	
	global $auth_config;
	// uložení atributů do promenných
	$user = base64_decode($_REQUEST['attrs']);
	$user = json_decode($user,TRUE);
	// ověření pravosti dat
	$signature = $_REQUEST['signature'];
	$signature_algo = $_REQUEST['signature_algo'];	 
	if ($signature_algo !== 'sha1')
	    return FALSE;
	$my_signature = sha1($_REQUEST['attrs'].$auth_config['key']);
	if ($signature !== $my_signature)
	    return FALSE;	
	return $user;
    }
    
    function auth_check_token($token) {
	global $auth_config;
	$signature = sha1($token.$auth_config['key']);	
	$url = $auth_config['url'].'app/'.$auth_config['app'].'/check/'.$token.'/sha1/'.$signature;    
	$data = fopen($url,"r");
	$response = '';
	while ($r = fread($data,1024))
	    $response .= $r;
	fclose($data);
	$response = explode("\n",$response);
	if ($response[0] == 'SESSION-OK') {
	    return json_decode($response[1],TRUE);
	} elseif ($response[0] == 'INVALID-SESSION')
	    return FALSE;
	else
	    return NULL;    
    }
    